"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.array.find");

require("core-js/modules/es6.function.name");

var _ = require("./");

var _react = require("react");

var _link = _interopRequireDefault(require("next/link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * @description
 * Link component based on [next/link](https://github.com/zeit/next.js/#with-link)
 * It is possible to use this component exactly the same as Next.js <Link> component but it has some extra props.
 *
 * - **name** Route name
 * - **params** Route parameters (note: this is also the place to define your subdomain variables)
 * - **domain** Route domain (note: if the domain differs from the current active domain, push state won't be triggered)
 * - **query** Additional query parameters
 *
 * @function Link
 *
 * @param {Object} props Props that are used by next-avenues: (name:string, params:?Object, domain:?string, query:?object).
 * @returns {React.Element}
 *
 * @example
 * <Link name="article" domain="blog.next-avenues.com" params={{slug: 'lorem-ipsum'}} query={{ q: 'search' }} ><a>link</a><Link>
 */
var Link = function Link(_ref) {
  var name = _ref.name,
      params = _ref.params,
      domain = _ref.domain,
      protocol = _ref.protocol,
      query = _ref.query,
      newProps = _objectWithoutProperties(_ref, ["name", "params", "domain", "protocol", "query"]);

  try {
    var route = _.store.find(name, domain || _.router.domain);

    var nextLinkProps = route.getNextLinkProps(params, {
      domain: domain,
      protocol: protocol,
      query: query
    });
    return (0, _react.createElement)(_link.default, _objectSpread({}, newProps, nextLinkProps));
  } catch (e) {
    // Fallback to Next.js Link component.
    return (0, _react.createElement)(_link.default, _objectSpread({}, newProps));
  }
};

var _default = Link;
exports.default = _default;